1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
86
87
88
89
90
91
92
93
94
95
96
97
98
99
100
101
102
103
104
105
106
107
108
109
110
111
112
113
114
115
116
117
118
119
120
121
122
123
124
125
126
127
128
129
130
131
132
133
134
135
136
137
138
139
140
141
142
143
144
145
|
--- gnats/gnats-edit-pr.sh.orig Tue Apr 20 16:17:07 1999
+++ gnats/gnats-edit-pr.sh Sun May 28 09:27:12 2000
@@ -124,15 +124,20 @@
*)
if [ "`echo $1 | grep /`" != "" ]; then
- pr_id=`echo $1 | awk -F"/" '{print $2}' -`
+ pr=`echo $1 | awk -F"/" '{print $2}' -`
else
- pr_id=$1
+ pr=$1
fi
+ prs="$prs $pr"
;;
esac
shift
done
+chng_msg="/tmp/chng.$$"
+
+for pr_id in $prs ; do
+
# set command here to always pass host and port, and directory if supplied
if [ "$mode" = "network" ]; then
prog="nedit-pr"
@@ -149,12 +154,12 @@
fi
# These traps take care of deleting all the /tmp files
-trap 'rm -f $new $new.old $change_msg ; exit 0' 0
+trap 'rm -f $new $new.old $change_msg $chng_msg; exit 0' 0
trap 'if [ "$locked" != "" ]; then \
$PR_EDIT --unlock $pr_id ; \
locked= ; \
fi ; \
- rm -f $new $new.old $change_msg ; exit 1' 1 2 3 13 15
+ rm -f $new $new.old $change_msg $chng_msg; exit 1' 1 2 3 13 15
# find a user name
if [ "$USER" != "" ]; then
@@ -192,7 +197,7 @@
if cmp -s $new.old $new ; then
echo "$prog: PR not changed"
$PR_EDIT --unlock $pr_id
- exit 0
+ continue
fi
# error-check output by calling pr-edit --check; if mistakes exist,
@@ -229,6 +234,8 @@
new_resp="`sed -n '/^>Responsible:/{s,^>[-a-zA-Z]*: *,,;s, *(.*,,g;p;q;}' $new`"
old_synopsis="`sed -n '/^>Synopsis:/{s,^>[-a-zA-Z]*: *,,;p;q;}' $new.old`"
new_synopsis="`sed -n '/^>Synopsis:/{s,^>[-a-zA-Z]*: *,,;p;q;}' $new`"
+old_class="`sed -n '/^>Class:/{s,^>[-a-zA-Z]*: *,,;p;q;}' $new.old`"
+new_class="`sed -n '/^>Class:/{s,^>[-a-zA-Z]*: *,,;p;q;}' $new`"
full_id="`sed -n '/^>Category:/{s,^>[-a-zA-Z]*: *,,;p;q;}' $new`/$pr_id"
# If you can read this, you may have a future in sed(1) programming.
@@ -256,8 +263,12 @@
if [ "$old_resp" != "$new_resp" ]; then
resp_change=yes
fi
+if [ "$old_class" != "$new_class" ]; then
+ class_change=yes
+fi
-if [ ! -z "$state_change" ] || [ ! -z "$resp_change" ]; then
+if [ ! -z "$state_change" ] || [ ! -z "$resp_change" ] || \
+ [ ! -z "$class_change" ]; then
# we've got a change
mail_to="$me"
if [ ! -z "$state_change" ]; then
@@ -266,14 +277,38 @@
echo State-Changed-By: $me >> $change_msg
echo State-Changed-When: $DATE >> $change_msg
echo "State-Changed-Why: " >> $change_msg
- echo 'Why did the state change? (Ctrl-D to end)'
- cat >> $change_msg
+ if [ -e $chng_msg ]; then
+ echo "Re-use last message (y/n)?"
+ read yesno
+ if [ "$yesno" != "y" ]; then
+ cat /home/gnats/gnats-adm/edit-pr-msg > $chng_msg
+ fi
+ else
+ cat /home/gnats/gnats-adm/edit-pr-msg > $chng_msg
+ fi
+ $VISUAL $chng_msg
+ sed '/^GNATS:/d' $chng_msg >> $change_msg
to_old=1
to_subm=1
+ if [ ! -z "$class_change" ] || [ ! -z "$resp_change" ]; then
+ echo "" >> $change_msg
+ echo "" >> $change_msg
+ fi
fi
- if [ ! -z "$state_change" ] && [ ! -z "$resp_change" ]; then
- echo "" >> $change_msg
- echo "" >> $change_msg
+ if [ ! -z "$class_change" ]; then
+ $debug_print "Doing class change."
+ echo Class-Changed-From-To: "$old_class"'->'"$new_class" >> $change_msg
+ echo Class-Changed-By: $me >> $change_msg
+ echo Class-Changed-When: $DATE >> $change_msg
+ echo "Class-Changed-Why: " >> $change_msg
+ echo 'Why did the class change? (Ctrl-D to end)'
+ cat >> $change_msg
+ to_old=1
+ to_new=1
+ if [ ! -z "$resp_change" ]; then
+ echo "" >> $change_msg
+ echo "" >> $change_msg
+ fi
fi
if [ ! -z "$resp_change" ]; then
$debug_print "Doing responsible change."
@@ -287,6 +322,9 @@
to_new=1
fi
+ echo "" >> $change_msg
+ echo "http://www.freebsd.org/cgi/query-pr.cgi?pr=$pr_id" >> $change_msg
+
if [ -n "$to_subm" ]; then mail_to="${reply_to}, ${mail_to}" ; fi
if [ -n "$x_gnats_notify" ]; then mail_to="${x_gnats_notify}, ${mail_to}" ; fi
if [ -n "$to_old" ] ; then mail_to="${mail_to}, `$PR_ADDR ${old_resp}`" ; fi
@@ -303,7 +341,7 @@
$MAIL_AGENT << __EOF__
To: $mail_to
From: $me
-Subject: Re: $full_id
+Subject: Re: $full_id: $new_synopsis
`if [ "$old_synopsis" != "$new_synopsis" ]; then
echo Old Synopsis: "$old_synopsis"
@@ -321,5 +359,9 @@
# call PR_EDIT on the new file and clean up
$PR_EDIT < $new
$PR_EDIT --unlock $pr_id
+
+done
+
+rm -f $chng_msg
exit 0
|